" Vim syntax file
" Language:     Unci unit testing
" Maintainer:   Don Blaheta <unci@blahedo.org>
" Last Change:  2014 Jan 29
"
" Based on the C++ syntax file by Ken Shan

"Add this file to a syntax directory inside ~/.vim or $VIM

" For version 6.x: Quit when a syntax file was already loaded
if version < 600
  syntax clear
elseif exists("b:current_syntax")
  finish
endif

" Read the C++ syntax to start with
if version < 600
  so <sfile>:p:h/cpp.vim
else
  runtime! syntax/cpp.vim
  unlet b:current_syntax
endif

syn keyword unciGroup		fixture tests
syn keyword unciBlocktype	test suite setup teardown
syn keyword unciCheck		check
syn keyword unciExpect		expect contained
syn keyword unciExpectType	true false throw trace about array contained
syn match unciPlusMinus		/+-/ 
syn match unciExpectType	/==\|!=\|<=\|>=\|<\|>/  contained
syn match unciExpectPair	/expect\s*[a-zA-Z<>=!]*/ contains=unciExpect,unciExpectType

"This blocks over-matching on unciExpectType
syn match cComparisonOp		/==\|!=\|<=\|>=\|<\|>/

" Default highlighting
if version >= 508 || !exists("did_cpp_syntax_inits")
  if version < 508
    let did_cpp_syntax_inits = 1
    command -nargs=+ HiLink hi link <args>
  else
    command -nargs=+ HiLink hi def link <args>
  endif
  HiLink unciGroup		cppAccess
  HiLink unciBlocktype		cppStructure
  HiLink unciCheck		cppStatement
  HiLink unciExpect		cppStatement
  HiLink unciExpectType		cppType
  HiLink unciPlusMinus		cppType
  delcommand HiLink
endif



let b:current_syntax = "unci"
