#include <cppunit/TestFixture.h>
#include <cppunit/TextTestRunner.h>
#include <cppunit/extensions/HelperMacros.h>

#include "Point.h"

class Point_test  : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( Point_test );
  CPPUNIT_TEST( test_getx );
  CPPUNIT_TEST( test_manhattan );
  CPPUNIT_TEST_SUITE_END();


  private:
    Point pt34;
    Point pt00;
    Point pt5n12;
  public:
    void setUp()
    {
      pt34 = Point (3, 4);
      pt00 = Point ();
      pt5n12 = Point (5, -12);
    }

    void test_getx()
    {
      CPPUNIT_ASSERT_EQUAL ( 3,  pt34.get_x() );
      CPPUNIT_ASSERT_EQUAL ( 5, pt5n12.get_x() );
    }
    void test_manhattan()
    {
      CPPUNIT_ASSERT ( pt34.manhattan(pt00) == 7 );
      CPPUNIT_ASSERT ( pt34.manhattan(pt5n12) == 18 );
      CPPUNIT_ASSERT ( pt5n12.manhattan(pt34) == 18 );
    }
};


int main( int argc, char **argv)
{
  CppUnit::TextTestRunner runner;
  runner.addTest( Point_test::suite() );
  runner.run();
  return 0;
}
